;************************************************************************/
;*	Copyright (C) 1986-1990 Phar Lap Software, Inc.			*/
;*	Unpublished - rights reserved under the Copyright Laws of the	*/
;*	United States.  Use, duplication, or disclosure by the 		*/
;*	Government is subject to restrictions as set forth in 		*/
;*	subparagraph (c)(1)(ii) of the Rights in Technical Data and 	*/
;*	Computer Software clause at 252.227-7013.			*/
;*	Phar Lap Software, Inc., 60 Aberdeen Ave., Cambridge, MA 02138	*/
;************************************************************************/

	include dosx.ah

       	assume cs:code
code	segment dword 'CODE'
comment ~*********************************************************************

call_child(ldblkp)
LDEXP_BLK *ldblkp;

Description:
	Does a FAR call to the child program, returns when it returns.
	All regs except EAX are preserved;  EAX contains the value returned
	by the child.

	NOTE this routine saves context on the child's stack.  If the child
	program does not return with the same stack you will have to
	modify this code!

Calling arguments:
	ldblkp		ptr to param block ret'd by load EXP file system call

Returned values:
	Value returned by child program
~*****************************************************************************
	public	call_child
call_child proc	near
;
; Stack frame
;
#LDBLKP	equ	(dword ptr 8[ebp])

	push	ebp			; Set up stack frame
	mov	ebp,esp				;
	push	ebx			; save regs
	push	ecx				;
	push	edx				;
	push	esi				;
	push	edi				;
	push	ds				;
	push	es				;
	push	fs				;
	push	gs				;

	mov	ebx,#LDBLKP		; get ptr to regs struct
	mov	cx,ss			; save current stack
	mov	edx,esp				;
	lss	esp,pword ptr [ebx].LX_ESP ; set up child's stack
	push	ecx			; save our old stack on child's stack
	push	edx				;
	push	cs			; FAR return point below
	lea	eax,#ret			;
	push	eax				;
	pushfd				; set up entry point in child
	movzx	eax,[ebx].LX_CS			;
	push	eax				;
	push	[ebx].LX_EIP			;
	mov	es,[ebx].LX_ES		; init rest of child's regs
	mov	fs,[ebx].LX_FS			;
	mov	gs,[ebx].LX_GS			;
	mov	ds,[ebx].LX_DS			;
	xor	eax,eax				;
	xor	ebx,ebx				;
	xor	ecx,ecx				;
	xor	edx,edx				;
	xor	esi,esi				;
	xor	edi,edi				;
	xor	ebp,ebp				;
	iretd				; transfer control to child
#ret:
	lss	esp,pword ptr [esp]	; restore our original stack

	pop	gs			; restore regs & return to caller
	pop	fs				;
	pop	es				;
	pop	ds				;
	pop	edi				;
	pop	esi				;
	pop	edx				;
	pop	ecx				;
	pop	ebx				;
	pop	ebp				;
	ret					;
call_child endp
code	ends
end
